/* Client per richiedere il numero di file in un direttorio remoto */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <dirent.h>
#include <fcntl.h>
#define LENGTH_FILE_NAME 20


int main(int argc, char **argv)
{
  struct hostent *host;
  struct sockaddr_in clientaddr, servaddr;
  int  sd, len, num_file;
  char nome_dir[LENGTH_FILE_NAME];



  /* CONTROLLO ARGOMENTI ---------------------------------- */
  if(argc!=3)
  {
    printf("Error:%s serverAddress serverPort\n", argv[0]);
    exit(1);
  }


  /* PREPARAZIONE INDIRIZZO CLIENT E SERVER ----------------------------- */
  memset((char *)&clientaddr, 0, sizeof(struct sockaddr_in));
  clientaddr.sin_family = AF_INET;
  clientaddr.sin_addr.s_addr = INADDR_ANY;  
  /* Passando 0 ci leghiamo ad un qualsiasi indirizzo libero,
   * ma cio' non funziona in tutti i sistemi.
   * Se nel nostro sistema cio' non funziona come si puo' fare?
   */
  clientaddr.sin_port = 0;

  memset((char *)&servaddr, 0, sizeof(struct sockaddr_in));
  servaddr.sin_family = AF_INET;
  host = gethostbyname (argv[1]);
  if (host == NULL)
  {
    printf("%s not found in /etc/hosts\n", argv[1]);
    exit(2);
  }
  else
  {
    servaddr.sin_addr.s_addr=((struct in_addr *)(host->h_addr))->s_addr;
    servaddr.sin_port = htons(atoi(argv[2]));
  }

  printf("Client avviato\n");

  /* CREAZIONE SOCKET ---------------------------- */
  sd=socket(AF_INET, SOCK_DGRAM, 0);
  if(sd<0) {perror("apertura socket"); exit(3);}
  printf("Creata la socket sd=%d\n", sd);
  /* BIND SOCKET, a una porta scelta dal sistema --------------- */
  if(bind(sd,(struct sockaddr *) &clientaddr, sizeof(clientaddr))<0)
  {perror("bind socket "); exit(1);}
  printf("Client: bind socket ok, alla porta %i\n", clientaddr.sin_port);


  /* CORPO DEL CLIENT: */
  /* ciclo di accettazione di richieste di conteggio ------- */

  printf("Richieste di conteggio fine del file di input\n");
  printf("Qualsiasi tasto per procedere, EOF per terminare\n");
  printf("Nome del direttorio: ");

  while (gets(nome_dir))
  {

    printf("Richiesto conteggio dei file in %s \n", nome_dir);

    /* invio richiesta */

    len=sizeof(servaddr);
    if (sendto(sd, nome_dir, (strlen(nome_dir)+1), 0, (struct sockaddr *)&servaddr, len)<0)
    {
      perror("scrittura socket");
      printf("Nome del direttorio: ");
      continue; // se questo invio fallisce il client torna all'inzio del ciclo
    }


    /* ricezione del risultato */

    printf("Attesa del risultato...\n");
    if (recvfrom(sd, &num_file, sizeof(num_file), 0, (struct sockaddr *)&servaddr, &len)<0)
    {
      perror("recvfrom");
      printf("Nome del direttorio: ");
      continue; // se questa ricezione fallisce il client torna all'inzio del ciclo
    }


    printf("Numero di file: %ld\n", ntohl(num_file));

    printf("Nome del direttorio: ");

  } // while



  printf("\nClient: termino...\n");
  close(sd);

  exit(0);
}
