/* Client per richiedere l'invio di un file (get, versione 1) */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#define DIM_BUFF 100
#define LENGTH_FILE_NAME 20

int main(int argc, char *argv[])
{
  int sd, nread;
  char c, ok, nome_file[LENGTH_FILE_NAME];
  struct hostent *host;
  struct sockaddr_in servaddr;  



  /* CONTROLLO ARGOMENTI ---------------------------------- */
  if(argc!=3)
  {
    printf("Error:%s serverAddress serverPort\n", argv[0]);
    exit(1);
  }
  
  printf("Client avviato\n");


  /* PREPARAZIONE INDIRIZZO SERVER ----------------------------- */
  memset((char *)&servaddr, 0, sizeof(struct sockaddr_in));
  servaddr.sin_family = AF_INET;

  host = gethostbyname(argv[1]);
  if (host == NULL)
  {
    printf("%s not found in /etc/hosts\n", argv[1]);
    exit(2);
  }

  servaddr.sin_addr.s_addr=((struct in_addr*) (host->h_addr))->s_addr;
  servaddr.sin_port = htons(atoi(argv[2]));


  /* CREAZIONE E CONNESSIONE SOCKET (BIND IMPLICITA) ----------------- */
  sd=socket(AF_INET, SOCK_STREAM, 0);
  if (sd <0)
  {perror("apertura socket "); exit(3);}
  printf("Creata la socket sd=%d\n", sd);

  if (connect(sd,(struct sockaddr *) &servaddr, sizeof(struct sockaddr))<0)
  {perror("Errore in connect"); exit(4);}
  printf("Connect ok\n");


  /* CORPO DEL CLIENT: */
  /* ciclo di accettazione di richieste di file ------- */

  printf("Richieste di file fino alla fine del file di input\n");
  printf("Qualsiasi tasto per procedere, EOF per terminare\n");
  printf("Nome del file da richiedere: ");

  while (gets(nome_file))
  {

    if (write(sd, nome_file, (strlen(nome_file)+1))<0)
    {
      perror("write");
      printf("Nome del file da richiedere: ");
      continue;
    }
    printf("Richiesta del file %s inviata... \n", nome_file);

    if (read(sd, &ok, 1)<0)
    {
      perror("read");
      printf("Nome del file da richiedere: ");
      continue;
    }

    if (ok=='S')
    {
      printf("Ricevo il file:\n");
      while((nread=read(sd,&c,1))>0) // leggo a caratteri per individuare il fine file
        if (c!='\0')
        {
          write(1,&c,1);
        }
        else break;
    }
    else if (ok=='N') printf("File inesistente\n");

    printf("Nome del file da richiedere: ");

  }//while

  printf("\nClient: termino...\n");
  
  // Chiusura socket
  close(sd);

  exit(0);
  
}

